pub enum SiteError {
    PageNotFound(String),
    DataError(String),
    NetworkError(String)
}

pub trait Site {
    fn get_page(&self, url: &str) -> Result<Vec<u8>, ()>;
}

pub trait SiteControl<S: Site> {
    fn is_ok() -> bool;
    fn site(&self) -> S;
    fn can_update(&self) -> bool;
    fn repair(&mut self) -> Result<(), ()>;
    fn update(&mut self) -> Result<S, ()>;
}